#ifndef MEM_H
#define MEM_H  /* block for forever(or nest) loop */



#ifndef MEMORY_CHECK

#define MALLOC(x)   malloc(x)
#define FREE(x)     free(x)

#else /* MEMORY_CHECK */

#define MALLOC(x)   wcol_malloc(x)
#define FREE(x)     wcol_free(x)

#endif /* MEMORY_CHECK */




#ifdef USE_MLOCK

#define MLOCK(addr, len)    mlock((void*)addr, len)

#define XMLOCK(addr, len)   { \
        if(mlock((void*)addr, len)<0) { \
            Trace("fail mlock(%p,%d) (%d)\n", (char*)addr, len, errno); \
        } \
        else { \
        } \
    }

#else

#define MLOCK(addr, len)        /* nothing */

#endif


#endif /* MEM_H*/

