/* config.h.  Generated automatically by configure.  */
/*
 * config.h.in : setup for wcol with 'autoheader'
 *      by k-chinen@is.aist-nara.ac.jp, 1995
 *
 * $Id: config.h.in,v 1.6 1996/12/01 20:34:24 k-chinen Exp k-chinen $
 */


/***
 *** compiler parameters
 ***/


/* Define to empty if the keyword does not work.  */
/* #undef const */

/* Define to empty if the keyword does not work.  */
/* #undef inline */

/* Define to empty if the keyword does not work.  */
/* #undef volatile */


/***
 *** headers
 ***/

/* Define if you have the ANSI C header files.  */
#define STDC_HEADERS 1

/* Define if you have <malloc.h> doesn't define.  */
/* #undef HAVE_MALLOC_H */

/* Define if you don't have vprintf but do have _doprnt.  */
/* #undef HAVE_DOPRNT */

/* Define if you can safely include both <sys/time.h> and <time.h>.  */
#define TIME_WITH_SYS_TIME 1

/* Define if your <sys/time.h> declares struct tm.  */
/* #undef TM_IN_SYS_TIME */

/* Define if you have <sys/wait.h> that is POSIX.1 compatible.  */
#define HAVE_SYS_WAIT_H 1

/* Define if you have <vfork.h>.  */
/* #undef HAVE_VFORK_H */

/* Define if you have the <sys/select.h> header file.  */
#define HAVE_SYS_SELECT_H 1

/* Define if you have the <poll.h> header file.  */
#define HAVE_POLL_H 1

/* Define if you have the <fcntl.h> header file.  */
#define HAVE_FCNTL_H 1

/* Define if you have the <limits.h> header file.  */
#define HAVE_LIMITS_H 1

/* Define if you have the <sys/ioctl.h> header file.  */
#define HAVE_SYS_IOCTL_H 1

/* Define if you have the <sys/time.h> header file.  */
#define HAVE_SYS_TIME_H 1

/* Define if you have the <syslog.h> header file.  */
#define HAVE_SYSLOG_H 1

/* Define if you have the <unistd.h> header file.  */
#define HAVE_UNISTD_H 1

/* Define if you have the <stropts.h> header file.  */
/* #undef HAVE_STROPTS_H */




/***
 *** data structures
 ***/


/* Define to `long' if <sys/types.h> doesn't define.  */
/* #undef off_t */

/* Define to `quad_t' if <sys/types.h> doesn't define.  */
/* #undef HAVE_QUAD_T */

/* Define to `int' if <sys/types.h> doesn't define.  */
/* #undef pid_t */

/* Define as the return type of signal handlers (int or void).  */
#define RETSIGTYPE void


/* Define to `int' if <signals.h> doesn't define.  */
#define HAVE_SIG_ATOMIC_T 1

#define HAVE_SIGJMP_BUF 1

/*
#ifndef HAVE_SIG_ATOMIC_T
typedef int sig_atomic_t;
#endif
*/

#define HAVE_TYPEDEF_FD_SET 1


#define HAVE_UNION_WAIT 1

/* dirent/direct and DIR */
#define HAVE_DIRENT 1
/* #undef HAVE_DIRENT_T */

#define HAVE_MSG_CONTROL 1

/* #undef HAVE_S_TV2TS */
/* #undef HAVE_L_TV2TS */

#ifndef HAVE_S_TV2TS
#define timeval_to_timespec TIMEVAL_TO_TIMESPEC
#define timespec_to_timeval TIMESPEC_TO_TIMEVAL
#endif


#define SIZEOF_INT 4
#define SIZEOF_SHORT 2
#define SIZEOF_LONG 4
#define SIZEOF_OFF_T 8





/***
 *** functions
 ***/



/* Define if you have the gettimeofday function.  */
#define HAVE_GETTIMEOFDAY 1

/* Define if you have the atexit function.  */
#define HAVE_ATEXIT 1

/* Define if you have the mkdir function.  */
#define HAVE_MKDIR 1

/* Define if you have the mktime function.  */
#define HAVE_MKTIME 1

/* Define if you have the select function.  */
#define HAVE_SELECT 1

/* Define if you have the poll function.  */
#define HAVE_POLL 1

/* Define if you have the socket function.  */
#define HAVE_SOCKET 1

/* Define if you have the socketpair function.  */
#define HAVE_SOCKETPAIR 1

/* Define if you have the sigaction function.  */
#define HAVE_SIGACTION 1

/* Define if you have the siglongjmp function.  */
#define HAVE_SIGLONGJMP 1

/* Define if you have the sigsetjmp function.  */
#define HAVE_SIGSETJMP 1

/* Define if you have the vprintf function.  */
#define HAVE_VPRINTF 1

/* Define if you have the sendmsg function.  */
#define HAVE_SENDMSG 1

/* Define if you have the recvmsg function.  */
#define HAVE_RECVMSG 1

/* Define if you have the putmsg function.  */
/* #undef HAVE_PUTMSG */

/* Define if you have the getmsg function.  */
/* #undef HAVE_GETMSG */

/* Define if you have the wait function.  */
#define HAVE_WAIT 1

/* Define if you have the waitpid function.  */
#define HAVE_WAITPID 1

/* Define if you have the wait3 function.  */
/* #undef HAVE_WAIT3 */


/***
 *** libraries
 ***/


/* Define if you have the m library (-lm).  */
#define HAVE_LIBM 1


#ifndef MUTEX_LOCK
#if 1
#define MUTEX_LOCK(x)       pthread_mutex_lock(x)
#define MUTEX_UNLOCK(x)     pthread_mutex_unlock(x)
#define MUTEX_TRYLOCK(x)    pthread_mutex_trylock(x)
#else
#define MUTEX_LOCK(x)    (fputs("lock", stderr),    pthread_mutex_lock(x))
#define MUTEX_UNLOCK(x)  (fputs("unlock", stderr),  pthread_mutex_unlock(x))
#define MUTEX_TRYLOCK(x) (fputs("trylock", stderr), pthread_mutex_trylock(x))
#endif
#endif






